<template>
  <span class="order-status-component" :style="style">{{ text }}</span>
</template>

<script>
import moment from "moment";
import * as preorder from "@/models/preorder";

export default {
  props: {
    order: {
      type: Object
    },
    nocolor: {
      type: Boolean,
      default: false
    }
  },

  computed: {
    style() {
      if (this.nocolor) {
        return {};
      }
      const color = {
        [preorder.STATUS_AWAIT]: "#4792ff",
        [preorder.STATUS_COMPLETED]: "#4792ff",
        [preorder.STATUS_CANCELED_BY_CUSTOMER]: "#de0716",
        [preorder.STATUS_READY]: "#4792ff",
        [preorder.STATUS_PREPARING]: "#de0716",
        [preorder.STATUS_CANCELED_BY_RESTAURANT]: "#de0716"
      }[this.order.OrderStauts];
      return {
        color
      };
    },

    text() {
      const reservationDate = moment(this.order.reservationTime * 1000).startOf(
        "day"
      );
      const today = moment().startOf("day");
      if (
        (this.order.status === preorder.STATUS_AWAIT ||
          this.order.status === preorder.STATUS_READY ||
          this.order.status === preorder.STATUS_PREPARING) &&
        today.isBefore(reservationDate, "day")
      ) {
        return this.$t("preorderStatus.crossDate");
      }
      return this.$t("preorderStatus." + this.order.OrderStauts);
    }
  }
};
</script>

<style lang="scss" scoped>
.order-status-component {
}
</style>
